class ThumbnailGenerateWorker
  include Sidekiq::Worker

  def perform(media_path, object_id)
    media = File.open media_path
    thumbnail_service.update_object(thumbnail_service.create_thumbnail(media), object_id)
  end

  private

  def thumbnail_service
    @@thumbnailService ||= ThumbnailService.new(generators)
  end

  def generators
    [
        Thumbnail::Strategies::VideoThumbnailGenerator.new,
        Thumbnail::Strategies::ImageThumbnailGenerator.new,
        Thumbnail::Strategies::PdfThumbnailGenerator.new
    ]
  end
end
